import 'dart:async';
import 'dart:io';

import 'package:barback/barback.dart';
import 'package:package_resolver/package_resolver.dart';
import 'package:sass/sass.dart' as sass;

class ToCss extends Transformer {
  ToCss.asPlugin();

  Future<bool> isPrimary(AssetId id) async =>
      id.extension == '.scss' || id.extension == '.sass';

  Future apply(Transform transform) async {
    var resolver = await SyncPackageResolver.loadConfig(
        new Uri.file(Directory.current.uri.toFilePath() + '.packages'));
    var newAsset = new Asset.fromString(
        transform.primaryInput.id.changeExtension('.css'),
        sass.render(transform.primaryInput.id.path,
            color: true, packageResolver: resolver));
    transform.consumePrimary();
    transform.addOutput(newAsset);
  }
}
